


#include <jni.h>
#include <android/log.h>



#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define  LOG_TAG    "testApp"
#define  LOGI(...)  __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)
#define  LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)

																		//ύXׂӏ
#define NATIVE_CALL(type, name) extern "C" JNIEXPORT type JNICALL Java_pkg_sample_imagerecognition_ImageProcessing_ ## name

int table_RGB[32][32][256];
unsigned short table_RGB565[32][32][256];

int mYStep,mCrStep,mCbStep;
int mWidth;
int mHeight;
int mSize;
unsigned char mImageChache[480 * 320];
unsigned char mImageChacheC[480*320/4];


int table_spiral_x[64*64];
int table_spiral_y[64*64];


void initSpiral(){//Qɑ邽߂̍We[u̍쐬

	int x_pos=0,y_pos=0;

	int way =0;
	int way_count=0;
	int next_corner=0;

	for(int cnt=0;cnt<64*64;cnt++){

		table_spiral_x[cnt]=x_pos;
		table_spiral_y[cnt]=y_pos;

		if(way==0)y_pos++;
		if(way==1)x_pos--;
		if(way==2)y_pos--;
		if(way==3)x_pos++;

		if(way_count++==next_corner/2){
			way=(way+1)%4;
			way_count=0;
			next_corner++;
		}
	}
}



int serchImage[16][16];
unsigned char serchImageU[16][16];
unsigned char serchImageV[16][16];
int mini_x=0,mini_y=0;
int mini_c=0xffffff;
int s_count=0;

void getSerchImage(unsigned char *aSrc,int x,int y){
	if(x<16||y<16||x>mWidth-16||y>mHeight-16)return;
	int i, j;
	int aCptr=(x&0x0fffe)+mSize;//UV

	for (j = -8; j < 8; j ++) {
		for (i = -8; i < 8; i ++){
			serchImage[i+8][j+8]=aSrc[(j*2+y) * (mWidth)+x+i*2];
			serchImageU[i+8][j+8]=aSrc[(j*2+y) * (mWidth>>1)+i*2+aCptr];
			serchImageV[i+8][j+8]=aSrc[(j*2+y) * (mWidth>>1)+i*2+aCptr+1];
		}
	}
}

void putSerchImage(int *aDst,int x,int y,int color){
	if (aDst == NULL)return;

	int i, j;
	for (j = -8; j < 8; j ++) {
		aDst[(j*2+y) * (mWidth)+x+-8*2]=color;
		aDst[(j*2+y) * (mWidth)+x+7*2]=color;
		aDst[(-8*2+y) * (mWidth)+x+j*2]=color;
		aDst[(7*2+y) * (mWidth)+x+j*2]=color;
	}
}

int compSerchImageGray(unsigned char *aSrc,int x,int y){


	int i, j,c;
	int sum=0;
	unsigned char *bytePtr;
	for (j = -8+1; j < 8; j ++) {
		for (i = -8+1; i < 8; i ++){
			c=(aSrc[(j*2+y) * (mWidth)+x+i*2]-serchImage[i+8][j+8]);

			c=c<<1;


			sum+=(c*c);
		}
		if(sum>mini_c)break;
	}
	return sum;
}
int compSerchImageColor(unsigned char *aSrc,int x,int y){


	int i, j,c,cu,cv;
	int sum=0;
	int aCptr=(x&0x0fffe)+mSize;//UV

	for (j = -8; j < 8; j ++) {
		for (i = -8; i < 8; i ++){
			//c=0;//aSrc[(j*2+y) * (mWidth)+x+i*2]-serchImage[i+8][j+8];
			cu=(serchImageU[i+8][j+8]-aSrc[(j*2+y) * (mWidth>>1)+i*2+aCptr]);
			cv=(serchImageV[i+8][j+8]-aSrc[(j*2+y) * (mWidth>>1)+i*2+aCptr+1]);
			sum+=(/*c*c+*/cu*cu+cv*cv)>>1;
		}
		if(sum>mini_c)break;
	}
	return sum;
}

int searchImage(unsigned char *aSrc,int *aDst,int flag){
	int i,j;
	int posx,posy;


	if ((flag&1) != 0) {
		s_count = 0;
		mini_x = mWidth / 2;
		mini_y = mHeight / 2;
		getSerchImage(aSrc, mWidth / 2, mHeight / 2);
	}
	else if (mini_c > 400000) {
		mini_c=0xffffff;
		s_count = 0;
		for (j = -64; j < 64; j += 2) {
			for (i = -96; i < 96; i += 2) {
				posx = mWidth / 2 + i;
				posy = mHeight / 2 + j;
				if (posx < 16 || posx >= mWidth - 16)
					continue;
				if (posy < 16 || posy >= mHeight - 16)
					continue;
				int c = compSerchImageGray(aSrc, posx, posy);
				if (c >= mini_c)
					continue;
				c += compSerchImageColor(aSrc, posx , posy );

				if (c < mini_c) {
					mini_x = posx;
					mini_y = posy;
					mini_c = c;
				}
			}
		}
		putSerchImage(aDst, mini_x, mini_y, 0xff00ff00);

	} else {
		mini_c = 0xffffff;

		if (mini_x == 0) {
			mini_x = mWidth / 2;
			mini_y = mHeight / 2;
		}
		int last_x = mWidth / 2 - mini_x;
		int last_y = mHeight / 2 - mini_y;

		for (int ncnt = 0; ncnt < 64 * 64; ncnt++) {
			posx = mWidth / 2 + table_spiral_x[ncnt] - last_x;
			posy = mHeight / 2 + table_spiral_y[ncnt] - last_y;
			if (posx < 16 || posx >= mWidth - 16)
				continue;
			if (posy < 16 || posy >= mHeight - 16)
				continue;
			int c = compSerchImageGray(aSrc, posx, posy);
			if (c >= mini_c)
				continue;
			c += compSerchImageColor(aSrc, posx , posy );

			if (c < mini_c) {
				mini_x = posx;
				mini_y = posy;
				mini_c = c;
			}
		}
		if (s_count <256)
			putSerchImage(aDst, mini_x, mini_y, 0xffff00ff | ((s_count)<< 8));
		else {
			s_count = 0;
			getSerchImage(aSrc, mini_x, mini_y);
			putSerchImage(aDst, mini_x, mini_y, 0xffff00ff | ((s_count)<< 8));
		}
	}


	return (mini_x*1000+mini_y);
}















NATIVE_CALL(void, initTable)(JNIEnv * env, jobject obj, jint aWidth,
		jint aHeight,jint aY,jint aCr, jint aCb) {
	mWidth = aWidth;
	mHeight = aHeight;
	mSize = mWidth * mHeight;

//	R	= Y+1.402Cr
//	G	= Y-0.714Cr-0.344Cb
//	B	= Y+1.772Cb

		initSpiral();

		mYStep=aY;
		mCrStep=aCr;
		mCbStep=aCb;

		if(aY!=8){
		for(int Y_c=-128+(1<<aY>>1);Y_c<128; Y_c+=(1<<aY)){
			int Y = Y_c;
			if (Y < 0)Y += 256;
			int Y_p = ((unsigned char) Y_c)>>aY;
			for(int Cr_c=-128+(1<<aCr>>1);Cr_c<128; Cr_c+=(1<<aCr)){
				int Cr = Cr_c;
				if (Cr < 0)Cr += 127;		else	Cr -= 128;
				int R = Y+1.402*Cr;
				if (R < 0)R = 0;			else if (R > 255)R = 255;
				int Cr_p = ((unsigned char)Cr_c) >> aCr;
				for(int Cb_c=-128+(1<<aCb>>1);Cb_c<128; Cb_c+=(1<<aCb)){
					int Cb_p = ((unsigned char)Cb_c) >> aCb;
					int Cb = Cb_c;
					if (Cb < 0)Cb += 127;	else	Cb -= 128;
					int B = Y+1.772*Cb;
					if (B < 0)B = 0;		else if (B > 255)B = 255;
					int G = Y-0.714*Cr-0.344*Cb;
					if (G < 0)G = 0;		else if (G > 255)G = 255;
					table_RGB[Cr_p][Cb_p][Y_p] = 0xff000000 | (R << 16) | (G<< 8) | B;
					table_RGB565[Cr_p][Cb_p][Y_p]=((R<<8)&0xF800) | ((G<<3)&0x7E0) | ((B>>3)&0x1F);
				}
			}
		}
	}
}




NATIVE_CALL(jint, convertYUV2RGB8888)(JNIEnv * env, jobject obj, jbyteArray jSrc,jbyteArray jDst,jint flag) {
	jboolean b;
	unsigned char *aSrc = (unsigned char *) env->GetPrimitiveArrayCritical(jSrc,&b);//GetByteArrayElements(jSrc, &b);
	jint *aDst = (jint *)env->GetPrimitiveArrayCritical(jDst,&b);//GetIntArrayElements(jDst, &b);

	int i, j;
	unsigned char *aSrcPtr=aSrc;
	int *aDstPtr=aDst;
	unsigned char *aCptr= aSrc + mSize;
	int *tablePtr;

	//ImageFilter3x3(aSrc,mFilter3x3_sharp1);

	for (j = 0; j < mHeight; j+=2) {
		for (i = 0; i < mWidth; i += 2) {
			tablePtr=&table_RGB[ *aCptr++ >> mCrStep][*(++aCptr) >> mCbStep][0];
			*(aDstPtr+mWidth) =*(tablePtr+(*(aSrcPtr+mWidth)>>mYStep));			*aDstPtr++ = *(tablePtr+(*(aSrcPtr++)>>mYStep));
			*(aDstPtr+mWidth) =*(tablePtr+(*(aSrcPtr+mWidth)>>mYStep));			*aDstPtr++ = *(tablePtr+(*(aSrcPtr++)>>mYStep));
		}
		aSrcPtr+=mWidth;
		aDstPtr+=mWidth;
	}

	int search_pos=searchImage(aSrc,aDst,flag);

	env->ReleasePrimitiveArrayCritical(jSrc, aSrc,0);//ReleaseByteArrayElements(jSrc, (jbyte *)aSrc, 0);
	env->ReleasePrimitiveArrayCritical(jDst, aDst, 0);//ReleaseIntArrayElements(jDst, aDst, 0);

	return (search_pos);
}


NATIVE_CALL(void, clippingRGB)(JNIEnv * env, jobject obj, /*jintArray*/jbyteArray jSrc, jintArray jDst,jint pos) {

	jboolean b;
	unsigned char *aSrc = (unsigned char *) env->GetPrimitiveArrayCritical(jSrc,&b);//GetByteArrayElements(jSrc, &b);
	jint *aDst = (jint *)env->GetPrimitiveArrayCritical(jDst,&b);//GetIntArrayElements(jDst, &b);

	int i, j;
	unsigned char Cr_p,Cb_p;
	int ds_posx=0,ds_posy=0;

	int posx=((pos/1000)>>1)<<1;
	int posy=pos%1000;

	int left=(posx-40);
	int top=posy-50;
	int right=left+80;
	int bottom=top+100;

	if(left<0){ds_posx-=left;left=0;}
	if(top<0){ds_posy-=top;top=0;}
	if(right>mWidth)right=mWidth;
	if(bottom>mHeight)bottom=mHeight;

	int clipWidth=(right-left);

	unsigned char *aSrcPtr=aSrc;
	int *aDstPtr=aDst;
	unsigned char *aCptr;

	for (j = top; j < bottom; j++) {
		aSrcPtr=aSrc + j * mWidth+left;
		aDstPtr=aDst + (j-top+ds_posy) * 80+ds_posx;
		aCptr = aSrc + (mSize) + (j >> 1) * (mWidth)+left;
		for (i = left; i < right; i +=2) {
			Cr_p = *aCptr++ >> mCrStep;
			Cb_p = *aCptr++ >> mCbStep;
			*aDstPtr++ = table_RGB[Cr_p][Cb_p][*(aSrcPtr++)>>mYStep];
			*aDstPtr++ = table_RGB[Cr_p][Cb_p][*(aSrcPtr++)>>mYStep];
		}
	}
	env->ReleasePrimitiveArrayCritical(jSrc, aSrc,0);//ReleaseByteArrayElements(jSrc, (jbyte *)aSrc, 0);
	env->ReleasePrimitiveArrayCritical(jDst, aDst, 0);//ReleaseIntArrayElements(jDst, aDst, 0);
}

NATIVE_CALL(void, setNextSearchPos)(JNIEnv * env, jobject obj, jbyteArray jSrc, jint x,jint y){
	jboolean b;	//
	unsigned char *aSrc = (unsigned char *)env->GetByteArrayElements(jSrc, &b);

	mini_x=x;
	mini_y=y;
	getSerchImage(aSrc, mini_x, mini_y);
	env->ReleaseByteArrayElements(jSrc, (jbyte *)aSrc, 0);
}

