package pkg.sample.imagerecognition;

import android.app.Activity;
import android.content.Context;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.PixelFormat;
import android.graphics.PointF;
import android.media.FaceDetector;
import android.media.FaceDetector.Face;
import android.opengl.GLSurfaceView;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;

public class ImageProcessing extends Activity {
	FrameRateChecker mFPS = new FrameRateChecker(10); // t[[gmFp

	CameraCallback mCameraCallback = null; // JpNX
	GraphicsView mGraphicsView = null; // 摜`pNX


	int[] mIntImage = null; // ARGB8888 int^摜z
	byte[] mYBuffer = null;
	int mWidth = 240, mHeight = 160; // vr[TCY
	int mYStep = 2, mCrStep = 3, mCbStep = 3; // YUV̊Ԉ
	int mFrameCount = 0; // 񐔂̃JEg

	float mSizeWidth = 1, mSizeHeight = 1;

	int mSearchFlag=0;
	
	//Fpϐ
	int[] mClippingIntData;
	FaceDetector.Face[] faces = new FaceDetector.Face[1]; // ʎ󂯎p
	FaceDetector mFaceDetector;
	int numFaces = 0;//̐iA^Cŏ邽߂ɂЂƂj
	int search_pos_x = 120, search_pos_y = 80;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE); // ʂ̌ŌŒ
		this.getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN); // Sʕ\
		this.getWindow().addFlags(
				WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON); // X[v
		this.requestWindowFeature(Window.FEATURE_NO_TITLE); // ^Cg̔\


		final ViewGroup.LayoutParams layoutParams = new ViewGroup.LayoutParams(
				ViewGroup.LayoutParams.FILL_PARENT,
				ViewGroup.LayoutParams.FILL_PARENT);

		mCameraCallback = new CameraCallback(this);
		mCameraCallback.setClass(this);

		// View
		mGraphicsView = new GraphicsView(this);
		setContentView(mCameraCallback, layoutParams);
		addContentView(mGraphicsView, layoutParams);

		// SurfaceView
		/*
		 * setContentView(R.layout.main); mDrawSurfaceView
		 * =(DrawSurfaceView)findViewById(R.id.DrawSurfaceClass);
		 * addContentView(mCameraCallback, layoutParams);
		 */

		// GL
		/*
		 * setContentView(R.layout.main); mGLSurfaceView
		 * =(OverlayGLSurfaceView)findViewById(R.id.OpenGLClass);
		 * addContentView(mCameraCallback, layoutParams);
		 */

		//\
		addContentView(new StatusView(this), layoutParams);

	}

	// \pView
	public class StatusView extends View {
		Paint paint;
		String mStatusStr[] = { "", "", "", "", "" };

		public StatusView(Context context) {
			super(context);
			paint = new Paint();
		}
		
		Matrix init_matrix = new Matrix();
		float face_zoom = (float) 0.001;
		private void drawFaceImage(Canvas canvas){
			
			paint.setColor(Color.argb(255, 255, 255, 255));

			canvas.scale(mSizeWidth, mSizeHeight);

				canvas.drawLines(new float[] { (mWidth >> 1) - 8, mHeight >> 1,
						(mWidth >> 1) + 8, mHeight >> 1, mWidth >> 1,
						(mHeight >> 1) - 8, mWidth >> 1, (mHeight >> 1) + 8 },
						paint);

				canvas.drawLines(new float[] { 	search_pos_x - 16, search_pos_y - 16,	search_pos_x - 16, search_pos_y + 16,
												search_pos_x - 16, search_pos_y + 16,	search_pos_x + 16, search_pos_y + 16,
												search_pos_x + 16, search_pos_y + 16,	search_pos_x + 16, search_pos_y - 16,
												search_pos_x + 16, search_pos_y - 16,	search_pos_x - 16, search_pos_y - 16 }, paint);
				for (int i = 0; i < numFaces; i++) { // F
					Face face = faces[i];
					PointF midPoint = new PointF(0, 0);
					face.getMidPoint(midPoint); // Fʂ擾
					float eyesDistance = face.eyesDistance(); // Fʂ擾
					face_zoom = eyesDistance * 0.020f;
					paint.setStyle(Paint.Style.STROKE);
					if (eyesDistance == 20)
						paint.setColor(Color.argb(255, 255, 0, 0));
					else
						paint.setColor(Color.argb(255, 0, 255, 0));
					canvas.drawCircle(midPoint.x + search_pos_x - 40,(midPoint.y + search_pos_y - 50),(float) (eyesDistance * 1.5), paint);
				}

			canvas.setMatrix(init_matrix);



			if (mClippingIntData != null)
				canvas.drawBitmap(mClippingIntData, 0, 80,	480 - 80, 0, 80, 100, true, paint);
		
		
	}


		@Override
		protected void onDraw(Canvas canvas) {
			drawFaceImage(canvas);
			if (mFrameCount % 5 == 0) {
				mStatusStr[0] = mFPS.getString() + "fps ImageProcessing";
				if (mCameraCallback != null)
					mStatusStr[1] = mCameraCallback.mFPS.getString()
							+ "fps CameraPreview";

				mStatusStr[2] = mGraphicsView.mFPS.getString() + "fps View";

				mStatusStr[4] = "width:" + mWidth + " height:" + mHeight;
			}
			paint.setColor(Color.rgb(255, 255, 255));
			canvas.drawText(mStatusStr[0], 10, 10, paint);
			canvas.drawText(mStatusStr[1], 10, 10 + 12, paint);
			canvas.drawText(mStatusStr[2], 10, 10 + 12 * 2, paint);
			canvas.drawText(mStatusStr[3], 256, 10, paint);
			canvas.drawText(mStatusStr[4], 256, 10 + 12, paint);
		}
	}

	// vr[`pView
	private class GraphicsView extends View {
		private FrameRateChecker mFPS = new FrameRateChecker(10);
		Paint paint;

		public GraphicsView(Context context) {
			super(context);
			paint = new Paint();
		}

		@Override
		protected void onDraw(Canvas canvas) {
			this.mFPS.measurement();
			canvas.drawRGB(128, 128, 128);
			canvas.scale(mSizeWidth, mSizeHeight); // 摜ʃTCYŕ\
			canvas.drawBitmap(mIntImage, 0, mWidth, 0, 0, mWidth, mHeight,
					false, paint); // int^z𒼐ڕ`
		}

	}
	
	// L[
	@Override
	public boolean dispatchKeyEvent(KeyEvent event) {
		if (event.getAction() == KeyEvent.ACTION_UP) { // L[ꂽ
			switch (event.getKeyCode()) {
			case KeyEvent.KEYCODE_DPAD_CENTER: // L[
				mSearchFlag = 1;//				
				return true;
			default:
			}
		}
		return super.dispatchKeyEvent(event);
	}
	
	// CameraCallbackĂяo鏉p\bh
	public void initImageData(int cam_w, int cam_h, int scr_w, int scr_h) {
		mIntImage = new int[cam_w * cam_h];
		mYBuffer = new byte[cam_w * cam_h];
		mWidth = cam_w;
		mHeight = cam_h;

		mSizeWidth = (float) scr_w / cam_w;
		mSizeHeight = (float) scr_h / cam_h;
		
		mClippingIntData = new int[(80) * (120)];
		mFaceDetector = new FaceDetector(80, 100, faces.length);

		initTable(cam_w, cam_h, mYStep, mCrStep, mCbStep);
	}

	// CameraCallbackĂяoJp\bh
	void cameraLoop(byte yuv_data[]) {
		mFrameCount++;
		mFPS.measurement();//N[[ǧv(XbhŏĂȂ̂onPreviewFrameƂ)

		
		//NDKŏ
			int search_pos=convertYUV2RGB8888(yuv_data, mIntImage, mSearchFlag);//YUV420->ARGB8888
			clippingRGB(yuv_data, mClippingIntData, search_pos);
			numFaces = mFaceDetector.findFaces(Bitmap.createBitmap(mClippingIntData, 80,100, Bitmap.Config.RGB_565), faces); // Fs
			mSearchFlag=0;
			search_pos_y = search_pos % 1000;
			search_pos_x = search_pos / 1000;
				for (int i = 0; i < numFaces; i++) { // F
					Face face = faces[i];
					PointF midPoint = new PointF(0, 0);
					face.getMidPoint(midPoint); // Fʂ擾

					setNextSearchPos(yuv_data, (int) (midPoint.x
							+ search_pos_x - 40), (int) (midPoint.y
							+ search_pos_y - 50));
				}

	}


	static {
		System.loadLibrary("picture");
	}

	private native void initTable(int widht, int height, int aY, int aCr,
			int aCb);

	private native int convertYUV2RGB8888(byte[] src, int[] dst, int flag);
	
	private native void clippingRGB(byte[] src, int[] dst, int pos);
	private native void setNextSearchPos(byte[] src, int x, int y);



}