


#include <jni.h>
#include <android/log.h>



#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define  LOG_TAG    "testApp"
#define  LOGI(...)  __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)
#define  LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)

																		//ύXׂӏ
#define NATIVE_CALL(type, name) extern "C" JNIEXPORT type JNICALL Java_pkg_sample_imageprocessing_ImageProcessing_ ## name

int table_RGB[32][32][256];
unsigned short table_RGB565[32][32][256];

int mYStep,mCrStep,mCbStep;
int mWidth;
int mHeight;
int mSize;
unsigned char mImageChache[480 * 320];
unsigned char mImageChacheC[480*320/4];




NATIVE_CALL(void, initTable)(JNIEnv * env, jobject obj, jint aWidth,
		jint aHeight,jint aY,jint aCr, jint aCb) {
	mWidth = aWidth;
	mHeight = aHeight;
	mSize = mWidth * mHeight;

//	R	= Y+1.402Cr
//	G	= Y-0.714Cr-0.344Cb
//	B	= Y+1.772Cb

		mYStep=aY;
		mCrStep=aCr;
		mCbStep=aCb;

		if(aY!=8){
		for(int Y_c=-128+(1<<aY>>1);Y_c<128; Y_c+=(1<<aY)){
			int Y = Y_c;
			if (Y < 0)Y += 256;
			int Y_p = ((unsigned char) Y_c)>>aY;
			for(int Cr_c=-128+(1<<aCr>>1);Cr_c<128; Cr_c+=(1<<aCr)){
				int Cr = Cr_c;
				if (Cr < 0)Cr += 127;		else	Cr -= 128;
				int R = Y+1.402*Cr;
				if (R < 0)R = 0;			else if (R > 255)R = 255;
				int Cr_p = ((unsigned char)Cr_c) >> aCr;
				for(int Cb_c=-128+(1<<aCb>>1);Cb_c<128; Cb_c+=(1<<aCb)){
					int Cb_p = ((unsigned char)Cb_c) >> aCb;
					int Cb = Cb_c;
					if (Cb < 0)Cb += 127;	else	Cb -= 128;
					int B = Y+1.772*Cb;
					if (B < 0)B = 0;		else if (B > 255)B = 255;
					int G = Y-0.714*Cr-0.344*Cb;
					if (G < 0)G = 0;		else if (G > 255)G = 255;
					table_RGB[Cr_p][Cb_p][Y_p] = 0xff000000 | (R << 16) | (G<< 8) | B;
					table_RGB565[Cr_p][Cb_p][Y_p]=((R<<8)&0xF800) | ((G<<3)&0x7E0) | ((B>>3)&0x1F);
				}
			}
		}
	}
}


int mFilter3x3_sharp1[]=	{0,-1,0,-1,5,-1,0,-1,0			,1};
int mFilter3x3_sharp2[]=	{-1,-1,-1,-1,9,-1,-1,-1,-1		,1};
int mFilter3x3_smooth1[]=	{0,1,0,1,1,1,0,1,0				,5};
int mFilter3x3_smooth2[]=	{1,1,1,1,1,1,1,1,1				,9};
int mFilter3x3_edge[]=		{-1,-1,-1,-1,8,-1,-1,-1,-1		,1};

void ImageFilter3x3(unsigned char *aSrc,int *filter){
	int pixPtr;
	for (int j = 1; j < mHeight-1; j++) {
		pixPtr = (j) * mWidth+1;
		for (int i = 1; i < mWidth-1; i ++) {
			int v=(
				aSrc[pixPtr-1-mWidth]*filter[0]	+aSrc[pixPtr-mWidth	]*filter[1]		+aSrc[pixPtr+1-mWidth	]*filter[2]+
				aSrc[pixPtr-1		]*filter[3]	+aSrc[pixPtr		]*filter[4]		+aSrc[pixPtr+1			]*filter[5]+
				aSrc[pixPtr-1+mWidth]*filter[6]	+aSrc[pixPtr+mWidth	]*filter[7]		+aSrc[pixPtr+1+mWidth	]*filter[8])/filter[9];
			if(v>255)v=255;
			else if(v<0)v=0;
			mImageChache[pixPtr]=v;
			pixPtr++;
		}
	}

	for (int j = 1; j < mHeight-1; j++) {
		pixPtr = (j) * mWidth+1;
		memcpy(aSrc+pixPtr,mImageChache+pixPtr,mWidth-2);
	}
}



NATIVE_CALL(jint, convertYUV2RGB8888)(JNIEnv * env, jobject obj, jbyteArray jSrc,jbyteArray jDst,jint flag) {
	jboolean b;
	unsigned char *aSrc = (unsigned char *) env->GetPrimitiveArrayCritical(jSrc,&b);//GetByteArrayElements(jSrc, &b);
	jint *aDst = (jint *)env->GetPrimitiveArrayCritical(jDst,&b);//GetIntArrayElements(jDst, &b);

	int i, j;
	unsigned char *aSrcPtr=aSrc;
	int *aDstPtr=aDst;
	unsigned char *aCptr= aSrc + mSize;
	int *tablePtr;

	//ImageFilter3x3(aSrc,mFilter3x3_sharp1);

	for (j = 0; j < mHeight; j+=2) {
		for (i = 0; i < mWidth; i += 2) {
			tablePtr=&table_RGB[ *aCptr++ >> mCrStep][*(++aCptr) >> mCbStep][0];
			*(aDstPtr+mWidth) =*(tablePtr+(*(aSrcPtr+mWidth)>>mYStep));			*aDstPtr++ = *(tablePtr+(*(aSrcPtr++)>>mYStep));
			*(aDstPtr+mWidth) =*(tablePtr+(*(aSrcPtr+mWidth)>>mYStep));			*aDstPtr++ = *(tablePtr+(*(aSrcPtr++)>>mYStep));
		}
		aSrcPtr+=mWidth;
		aDstPtr+=mWidth;
	}

	env->ReleasePrimitiveArrayCritical(jSrc, aSrc,0);//ReleaseByteArrayElements(jSrc, (jbyte *)aSrc, 0);
	env->ReleasePrimitiveArrayCritical(jDst, aDst, 0);//ReleaseIntArrayElements(jDst, aDst, 0);

	return 0;
}






NATIVE_CALL(jint, convertYUV2RGB8888Quarter)(JNIEnv * env, jobject obj, jbyteArray jSrc,jbyteArray jDst,jint flag,jint count) {

	jboolean b;
	unsigned char *aSrc = (unsigned char *) env->GetPrimitiveArrayCritical(jSrc,&b);//GetByteArrayElements(jSrc, &b);
	jint *aDst = (jint *)env->GetPrimitiveArrayCritical(jDst,&b);//GetIntArrayElements(jDst, &b);


	int i, j;
	unsigned char Cr_p,Cb_p;
	unsigned char *aCptr=aCptr = aSrc + mSize;
	int x_pos=count&0x01;
	int y_pos=(count&0x02)>>1;
	int aPptr= (y_pos) * (mWidth)+x_pos;

	for (j = 0; j < mHeight; j+=2) {
		for (i = 0; i < mWidth; i += 2) {
			Cr_p = *aCptr++ >> mCrStep;
			Cb_p = *aCptr++ >> mCbStep;
			aDst[aPptr] = table_RGB[Cr_p][Cb_p][aSrc[aPptr]>>mYStep];
			aPptr+=2;
		}
		aPptr+=mWidth;
	}

	env->ReleasePrimitiveArrayCritical(jSrc, aSrc,0);//ReleaseByteArrayElements(jSrc, (jbyte *)aSrc, 0);
	env->ReleasePrimitiveArrayCritical(jDst, aDst, 0);//ReleaseIntArrayElements(jDst, aDst, 0);
	return (0);
}



NATIVE_CALL(jint, convertYUV2RGB565Tex)(JNIEnv * env, jobject obj, jbyteArray jSrc,jbyteArray jTex,jint flag) {
	jboolean b;
	unsigned char *aSrc = (unsigned char *) env->GetPrimitiveArrayCritical(jSrc,&b);//GetByteArrayElements(jSrc, &b);
	unsigned short *aTex = (unsigned short *) env->GetPrimitiveArrayCritical(jTex,&b);
	//unsigned short *aTex = (unsigned short *) env->GetByteArrayElements(jTex, &b);

	int i, j;
	int R,G,B;

	unsigned char *aSrcPtr=aSrc;
	unsigned short *aDstPtr=aTex;
	unsigned char *aCptr= aSrc + mSize;

	unsigned short *tablePtr;

	int texSize;
	if(mWidth<256)texSize=256;
	else if(mWidth<512)texSize=512;
	else if(mWidth<1024)texSize=1024;
	else texSize=2048;
	int texCount=texSize+(texSize-mWidth);



	for (j = 0; j < mHeight; j+=2) {
		for (i = 0; i < mWidth; i += 2) {
			tablePtr=&table_RGB565[ *aCptr++ >> mCrStep][*(++aCptr) >> mCbStep][0];
			*(aDstPtr+texSize) =*(tablePtr+(*(aSrcPtr+mWidth)>>mYStep));			*aDstPtr++ = *(tablePtr+(*(aSrcPtr++)>>mYStep));
			*(aDstPtr+texSize) =*(tablePtr+(*(aSrcPtr+mWidth)>>mYStep));			*aDstPtr++ = *(tablePtr+(*(aSrcPtr++)>>mYStep));
		}
		aSrcPtr+=mWidth;
		aDstPtr+=texCount;
	}
	env->ReleasePrimitiveArrayCritical(jSrc, aSrc,0);
	env->ReleasePrimitiveArrayCritical(jTex, aTex,0);
	//env->ReleaseByteArrayElements(jSrc, (jbyte *)aSrc, 0);
	//env->ReleaseByteArrayElements(jTex, (jbyte *)aTex, 0);
	return (0);
}


