package pkg.sample.imageprocessing;

import java.io.IOException;


import android.content.Context;
import android.hardware.Camera;
import android.hardware.Camera.Size;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class CameraCallback extends SurfaceView implements
		Camera.PreviewCallback, SurfaceHolder.Callback {
	private Camera _camera;
	private Size previewSize;
	int mCameraSize=1;
	
	public FrameRateChecker mFPS = new FrameRateChecker(10);
	
	public String mWhitebalanceStr[]=null;
	public int mWhitebalanceValue=0;
	public String mEffectStr[]=null;
	public int mEffectValue=0;

	ImageProcessing mClass = null;
	public void setClass(ImageProcessing aClass) {
		mClass = aClass;//ĂяoNXw
	}	

	public CameraCallback(Context c) {
		super(c);
		setSurfaceHolder();
	}

	public void setSurfaceHolder() {
		SurfaceHolder sHolder = getHolder();
		// sHolder.setFormat(PixelFormat.TRANSLUCENT);
		sHolder.addCallback(this);
		sHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
		this.setFocusable(true);
		this.requestFocus();
	}

	public void surfaceChanged(SurfaceHolder holder, int format, int width,	int height) {
		getCameraParametersStr();
		switch(mCameraSize){//肳ŌHT-03Aŗpłvr[TCY
		case 6:previewSize =this.setPreviewSize(640,480);break;
		case 5:previewSize =this.setPreviewSize(480,320);break;
		case 4:previewSize =this.setPreviewSize(384,288);break;		
		case 3:previewSize =this.setPreviewSize(352,288);break;
		case 2:previewSize =this.setPreviewSize(320,240);break;
		case 1:previewSize =this.setPreviewSize(240,160);break;
		case 0:previewSize =this.setPreviewSize(176,144);break;			
		}
		setWhitebalance(0);
		setEffect(0);

		
		mClass.initImageData(previewSize.width, previewSize.height,width,height);
		
		try {
			_camera.setPreviewDisplay(holder);
		} catch (IOException e) {
		}

		_camera.startPreview();
		_camera.setPreviewCallback(this);
		
	}
	
	public void surfaceCreated(SurfaceHolder holder) {
		_camera = Camera.open();
	}

	public void surfaceDestroyed(SurfaceHolder holder) {
		pausePreview();
		_camera.stopPreview();
		_camera.release();
		_camera = null;
	}

	public Size setPreviewSize(int width, int height) {
		Camera.Parameters parameters = _camera.getParameters();
		parameters.setPreviewSize(width , height ); // vr[TCY̎w
		_camera.setParameters(parameters);		
		return parameters.getPreviewSize();
	}
	public void setWhitebalance(int value){
		if (mWhitebalanceStr == null)return;
		mWhitebalanceValue=(value+mWhitebalanceStr.length)%mWhitebalanceStr.length;
		Camera.Parameters parameters = _camera.getParameters();
		parameters.set("whitebalance", mWhitebalanceStr[mWhitebalanceValue]);
		_camera.setParameters(parameters);		
	}
	public void setEffect(int value){
		if (mEffectStr == null)return;
		mEffectValue=(value+mEffectStr.length)%mEffectStr.length;
		Camera.Parameters parameters = _camera.getParameters();
		parameters.set("effect", mEffectStr[mEffectValue]);
		_camera.setParameters(parameters);		
	}
	public String getWhitebalanceStr(){
		if (mWhitebalanceStr == null)return null;
		return mWhitebalanceStr[mWhitebalanceValue];
	}
	public String getEffectStr(){
		if (mEffectStr == null)return null;
		return mEffectStr[mEffectValue];
	}
	//flattenŃJ̐ݒ𒲂ׂ
	private void getCameraParametersStr(){
		Camera.Parameters parameters = _camera.getParameters();
		String flatten_str_t[]=parameters.flatten().split(";");
		String flatten_str[][]=new String[flatten_str_t.length][];
		for(int i=0;i<flatten_str_t.length;i++){
			flatten_str[i]=flatten_str_t[i].split("=");
			Log.i("Camera.Parameters",flatten_str[i][0]+" = "+flatten_str[i][1]);
		
			if(flatten_str[i][0].equals("whitebalance-values"))mWhitebalanceStr=flatten_str[i][1].split(",");
			if(flatten_str[i][0].equals("effect-values"))mEffectStr=flatten_str[i][1].split(",");			
		}
		for(int i=0;i<mWhitebalanceStr.length;i++)
			Log.i("Camera.Parameters","whitebalance-values:"+i+" = "+mWhitebalanceStr[i]);
		for(int i=0;i<mEffectStr.length;i++)
			Log.i("Camera.Parameters","effect-values:"+i+" = "+mEffectStr[i]);
	}

	//vr[摜̎擾
	public void onPreviewFrame(byte[] data, Camera camera) {		
		mFPS.measurement();	//t[[ǧv		
		pausePreview();
		mClass.cameraLoop(data);
		restartPreview();
		invalidate();		
	}

	public void pausePreview(){
		if (_camera != null)_camera.setPreviewCallback(null);
	}
	public void restartPreview(){
		if (_camera != null)_camera.setPreviewCallback(this);		
	}
	

}